Foxit PDF SDK

Public Member Functions | List of all members
foxit.pdf.PSI Class Reference
Inheritance diagram for foxit.pdf.PSI:

## Public Member Functions
| PSI (Bitmap bitmap, bool simulate)
| Constructor, with a bitmap as canvas. More...
| PSI (int width, int height, bool simulate)
| Constructor, with specified width and height for canvas. More...
| PSI (PSI other)
| Constructor, with another PSI object. More...
void | AddPoint (PointF point, Path.PointType type, float pressure)
| Add a point. More...
PSInk | ConvertToPDFAnnot (PDFPage page, RectF annot_rect, Rotation rotate)
| Convert a PSI object to a PSInk annotation and insert the PSInk annotation to a PDF page. More...
Bitmap | GetBitmap ()
| Get the canvas bitmap. More...
RectF | GetContentsRect ()
| Get contents rectangle. More...
bool | IsEmpty ()
| Check whether current object is empty or not. More...
void | SetCallback (PSICallback callback)
| Set a callback object for refreshing. More...
void | SetColor (int color)
| Set ink color. More...
void | SetDiameter (int diameter)
| Set ink diameter. More...
void | SetOpacity (float opacity)
| Set ink opacity. More...

## Detailed Description

PSI, "pressure sensitive ink", is specially defined for manual signature, and usually works together with a handwriting board or for a touchscreen. PSI contains private coordinates, and a canvas is created in its coordinates. Canvas limits operating area and generates appearance of PSI.
PSI is independent of PDF, and can even be used directly in the device screen. If user wants to save a PSI object to PDF file, please call function PSI.ConvertToPDFAnnot . This function will convert PSI data to a PSInk annotation (as a Foxit custom annotation type) and insert the PSInk annotation to the specified position in a PDF page.

See also
  foxit.pdf.annots.PSInk

## Constructor & Destructor Documentation

## ◆ PSI() [1/3]

foxit.pdf.PSI.PSI | ( | Bitmap | bitmap,
|  | bool | simulate
| ) |  |
| inline

Constructor, with a bitmap as canvas.

Parameters

  [in] | bitmap | A bitmap used as canvas. It should be created with foxit.common.Bitmap.DIBFormat.e_DIBArgb format. User should ensure this bitmap to keep valid until current PSI object is released.
  [in] | simulate | Used to decide whether to turn on simulation of PSI or not: true means to turn on simulation, and false means to turn off simulation. It can simulate handwriting weights by writing speed when simulation is on.

## ◆ PSI() [2/3]

foxit.pdf.PSI.PSI | ( | int | width,
|  | int | height,
|  | bool | simulate
| ) |  |
| inline

Constructor, with specified width and height for canvas.

Parameters

  [in] | width | Width of PSI canvas in device coordinate system. This shall be greater than 0.
  [in] | height | Height of PSI canvas in device coordinate system. This shall be greater than 0.
  [in] | simulate | Used to decide whether to turn on simulation of PSI or not: true means to turn on simulation, and false means to turn off simulation. It can simulate handwriting weights by writing speed when simulation is on.

## ◆ PSI() [3/3]

foxit.pdf.PSI.PSI | ( | PSI | other | ) |
| inline

Constructor, with another PSI object.

Parameters

  [in] | other | Another PSI object.

## Member Function Documentation

## ◆ AddPoint()

void foxit.pdf.PSI.AddPoint | ( | PointF | point,
|  | Path.PointType | type,
|  | float | pressure
| ) |  |
| inline

Add a point.

Parameters

  [in] | point | A point in canvas coordinate system.
  [in] | type | Point type. This should be one of following values: foxit.common.Path.PointType.e_TypeMoveTo , foxit.common.Path.PointType.e_TypeLineTo , foxit.common.Path.PointType.e_TypeLineToCloseFigure ,
  [in] | pressure | Pressure value for this point. Valid range: from 0.0 to 1.0.

Returns
  None.

## ◆ ConvertToPDFAnnot()

PSInk foxit.pdf.PSI.ConvertToPDFAnnot | ( | PDFPage | page,
|  | RectF | annot_rect,
|  | Rotation | rotate
| ) |  |
| inline

Convert a PSI object to a PSInk annotation and insert the PSInk annotation to a PDF page.

Actually, this function is to convert the path data of current PSI to a PSInk annotation, ignoring the canvas bitmap.
Before calling this function, user should ensure that current PSI object has contained a valid path (whose last point's type is foxit.common.Path.PointType.e_TypeLineToCloseFigure . Otherwise, the conversion will be failed and this function will throw exception foxit.common.ErrorCode.e_ErrInvalidData .

Parameters

  [in] | page | A valid PDF page object, to which the PSI is expected to inserted.
  [in] | annot_rect | A rectangle to specify the position in the PDF page, where the new PSInk annotation will be inserted. It should be valid in PDF coordinate system".
  [in] | rotate | Rotation value. Currently, it can only be foxit.common.Rotation.e_Rotation0 .

Returns
  A new PSInk annotation object.

Note
  User do not need to call function annots.Annot.ResetAppearanceStream (inherited from PSInk's parent class) to reset the appearance of PSInk annotation after this conversion.

## ◆ GetBitmap()

Bitmap foxit.pdf.PSI.GetBitmap | ( |  | ) |
| inline

Get the canvas bitmap.

Returns
  Canvas bitmap.

## ◆ GetContentsRect()

RectF foxit.pdf.PSI.GetContentsRect | ( |  | ) |
| inline

Get contents rectangle.

Returns
  Contents rectangle, in device coordinate system. If current PSI object does not contain a valid path, a RectF object with all 0 values would be returned.

## ◆ IsEmpty()

bool foxit.pdf.PSI.IsEmpty | ( |  | ) |
| inline

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ SetCallback()

void foxit.pdf.PSI.SetCallback | ( | PSICallback | callback | ) |
| inline

Set a callback object for refreshing.

Parameters

  [in] | callback | A callback object PSICallback which is implemented by user. Please ensure that the callback object keeps valid until the life-cycle of current PSI object ends.

Returns
  None.

## ◆ SetColor()

void foxit.pdf.PSI.SetColor | ( | int | color | ) |
| inline

Set ink color.

This should be set before adding first point to PSI object. If not set, the default value 0x000000 will be used.

Parameters

  [in] | color | Ink color. Format: 0xRRGGBB.

Returns
  None.

## ◆ SetDiameter()

void foxit.pdf.PSI.SetDiameter | ( | int | diameter | ) |
| inline

Set ink diameter.

This should be set before adding first point to PSI object. If not set, the default value 10 will be used.

Parameters

  [in] | diameter | Ink diameter. This should be bigger than 1.

Returns
  None.

## ◆ SetOpacity()

void foxit.pdf.PSI.SetOpacity | ( | float | opacity | ) |
| inline

Set ink opacity.

This should be set before adding first point to PSI object. If not set, the default value 1.0 will be used.

Parameters

  [in] | opacity | Ink opacity. Valid range: from 0.0 to 1.0. 0.0 means full transparency and 1.0 means full opaque.

Returns
  None.